# Disable debug
%define debug_package %{nil}
%define __strip /bin/true
%define buildid 7287
%define jitsi_dir jitsi-videobridge-stable-jitsi-meet_%{buildid}

Name:           jitsi-videobridge
Summary:        Jitsi Videobridge is a WebRTC compatible video router or SFU
Version:        2.0.%{buildid}
Release:        1%{?dist}
License:        Apache 2.0
Source0:        jitsi-meet_%{buildid}.tar.gz
Source10:       config
Source12:       jvb.conf

BuildRequires:  maven
BuildRequires:  systemd
BuildRequires:  systemd-rpm-macros
Requires:       java-headless


%description
Jitsi Videobridge is a WebRTC compatible video router or SFU that lets build
highly scalable video conferencing infrastructure (i.e., up to hundreds of
conferences per server)

%prep
%setup -q -n %{jitsi_dir}

%build
mkdir -p %{_builddir}/%{jitsi_dir}/.m2/repository
mvn -Dmaven.repo.local=%{_builddir}/%{jitsi_dir}/.m2/repository versions:set -DnewVersion="%{version}"
mvn -Dmaven.repo.local=%{_builddir}/%{jitsi_dir}/.m2/repository -DskipTests package
mvn -Dmaven.repo.local=%{_builddir}/%{jitsi_dir}/.m2/repository -DskipTests -Dassembly.skipAssembly=true install
mvn -Dmaven.repo.local=%{_builddir}/%{jitsi_dir}/.m2/repository dependency:copy-dependencies -DincludeScope=runtime

%install
install -d $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/videobridge
install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysctl.d
install -d $RPM_BUILD_ROOT%{_unitdir}/
install -d $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge
install -d $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge/lib
install -d $RPM_BUILD_ROOT%{_rundir}
install -d $RPM_BUILD_ROOT%{_localstatedir}/log/jitsi


install -m 644 jvb/lib/logging.properties               $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/videobridge
install -m 644 %{SOURCE10}                              $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/videobridge
install -m 644 %{SOURCE12}                              $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/videobridge

install -m 644 config/logrotate                         $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/jitsi-videobridge
install -m 644 config/20-jvb-udp-buffers.conf           $RPM_BUILD_ROOT%{_sysconfdir}/sysctl.d

install -m 644 jvb/target/jitsi-videobridge-%{version}.jar       $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge/jitsi-videobridge.jar

cp -r jvb/target/dependency/*                           $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge/lib

install -m 644 jvb/lib/videobridge.rc                   $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge/lib
install -m 755 jvb/resources/jvb.sh                     $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge
install -m 755 resources/graceful_shutdown.sh           $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge
install -m 755 resources/collect-dump-logs.sh           $RPM_BUILD_ROOT%{_datadir}/jitsi-videobridge

# callstats-java-sdk
install -m 644 config/callstats-java-sdk.properties     $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/videobridge
install -m 644 debian/jitsi-videobridge2.service        $RPM_BUILD_ROOT%{_unitdir}

%pre
getent group jitsi >/dev/null || groupadd -r jitsi
getent passwd jvb >/dev/null || \
    useradd -r -g jitsi -d %{_datadir}/jitsi-videobridge -s /sbin/nologin \
    -c "Jitsi videobridge account" jvb
exit 0

%post
chown jvb.jitsi %{_localstatedir}/log/jitsi
chmod 770 %{_localstatedir}/log/jitsi
ls %{_localstatedir}/log/jitsi/jvb* 1>/dev/null 2>&1 && chown -f -R jvb:jitsi %{_localstatedir}/log/jitsi/jvb*
ls %{_localstatedir}/log/jitsi/jvb* 1>/dev/null 2>&1 && chmod -f -R 640 %{_localstatedir}/log/jitsi/jvb*

chown -R jvb:jitsi %{_datadir}/jitsi-videobridge
chown -R jvb:jitsi %{_sysconfdir}/jitsi/videobridge

%systemd_post jitsi-videobridge2.service

%preun
%systemd_preun jitsi-videobridge2.service

%postun
%systemd_postun_with_restart jitsi-videobridge2.service

%clean
mvn -Dmaven.repo.local=%{_builddir}/%{name}-%{version}/.m2/repository clean
%{__rm} -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README.md SECURITY.md CONFIG.md
%{!?_licensedir:%global license %%doc}
%license LICENSE

%{_unitdir}/jitsi-videobridge2.service

%dir %attr(0775, jvb, jitsi) %{_sysconfdir}/jitsi/videobridge
%attr(-, jvb, jitsi) %{_sysconfdir}/jitsi/videobridge/

%config(noreplace) %{_sysconfdir}/jitsi/videobridge/callstats-java-sdk.properties
%config(noreplace) %{_sysconfdir}/jitsi/videobridge/config
%config(noreplace) %{_sysconfdir}/jitsi/videobridge/jvb.conf
%config(noreplace) %{_sysconfdir}/jitsi/videobridge/logging.properties

%{_sysconfdir}/logrotate.d/jitsi-videobridge
%{_sysconfdir}/sysctl.d/20-jvb-udp-buffers.conf

%dir %attr(-, jvb, jitsi) %{_datadir}/jitsi-videobridge
%attr(-, jvb, jitsi) %{_datadir}/jitsi-videobridge
# % dir % attr(0770, jvb, jitsi) % {_localstatedir}/log/jitsi


%changelog
* Fri Jan 21 2022 Zoran Pericic <zpericic@infomaas.com> 2.0.6826-1
- Initial RPM release.

